<?php

function fn_redesk_connection_get_departments()
{
	$url = Registry::get('settings.redesk_connection.general.redesk_url');
	$api_key = Registry::get('settings.redesk_connection.general.api_key');

	Registry::register_cache('redesk_departments', 0, CACHE_LEVEL_TIME);
	$departments = Registry::get('redesk_departments');

	if ($url && $api_key && (Registry::is_exist('redesk_departments') == false || empty($departments)))
	{
		list(, $req) = fn_http_request('GET', $url . 'api/getDepartments', array ('api_key' => $api_key));
		$departments = fn_from_json($req);

		Registry::set('redesk_departments', $departments);
	}

	return $departments;
}

function fn_redesk_create_ticket($ticket)
{
	$url = Registry::get('settings.redesk_connection.general.redesk_url');
	$api_key = Registry::get('settings.redesk_connection.general.api_key');

	$ticket['api_key'] = $api_key;

	$post = $ticket;

	$files = fn_filter_uploaded_data('redesk_files');

	if (!empty($files))
	{
		foreach ($files as $k => $file)
		{
			$post['file_' . $k] = "@/$file[path]";
			$post['name_file_' . $k] = $file['name'];
			$post['type_file_' . $k] = $file['type'];
		}
	}

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url . 'api/createTicket');
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
	curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; Windows NT 6.1; en-GB; rv:1.9.2) Gecko/20100115 Firefox/3.6 (.NET CLR 3.5.30729)");
	$req = curl_exec($ch);
	curl_close($ch);

	return $req;
}